/*
----------------------------------------------------------------------

	AdAstra - Real Time Kernel

	Alain Chebrou

	WS2812B.c	Utilities for WS2812B color LEDs

	When		Who	What
	20/11/21	ac	Creation

----------------------------------------------------------------------
*/


#if ! defined WS2812B_H_
#define WS2812B_H_
//--------------------------------------------------------------------------------

#include	"spibasic.h"

//--------------------------------------------------------------------------------
// Colors

#define	ORANGE1		0x00FF2000
#define	ORANGE2		0x00801400
#define	ORANGE3		0x00400A00
#define	ORANGE4		0x00100300
#define	ORANGE5		0x00040100

#define	YELLOW1		0x00FF8000
#define	YELLOW2		0x00804000
#define	YELLOW3		0x00402000
#define	YELLOW4		0x00100800
#define	YELLOW5		0x00040200

#define	MAGENTA1	0x00FF0050
#define	MAGENTA2	0x00800028
#define	MAGENTA3	0x00400014
#define	MAGENTA4	0x00100005
#define	MAGENTA5	0x00040001

#define	CYAN1		0x0000FFFF
#define	CYAN2		0x00008080
#define	CYAN3		0x00004040
#define	CYAN4		0x00001010
#define	CYAN5		0x00000404

#define	RED1		0x00FF0000
#define	RED2		0x00800000
#define	RED3		0x00400000
#define	RED4		0x00100000
#define	RED5		0x00040000

#define	GREEN1		0x0000FF00
#define	GREEN2		0x00008000
#define	GREEN3		0x00004000
#define	GREEN4		0x00001000
#define	GREEN5		0x00000400

#define	BLUE1		0x000000FF
#define	BLUE2		0x00000080
#define	BLUE3		0x00000040
#define	BLUE4		0x00000010
#define	BLUE5		0x00000004

#define	WHITE1		0x00FFFFC8
#define	WHITE2		0x00808064
#define	WHITE3		0x00404032
#define	WHITE4		0x00101008
#define	WHITE5		0x00040402

#define	BLACK1		0x00000000

//--------------------------------------------------------------------------------
// Indexes of colors in wPalette

#define	IRED		1
#define	IGREEN		9
#define	IBLUE		17
#define	IORANGE		25
#define	IYELLOW		33
#define	IMAGENTA	41
#define	ICYAN		49
#define	IWHITE		57

extern	const	uint32_t	wPalette [] ;
extern	const	uint32_t	wPaletteCount ;	// Count of colors in the palette

//--------------------------------------------------------------------------------

uint32_t		wsGenerateBuffer	(const uint32_t * pPixel, uint8_t * pBuffer, uint32_t nb) ;
spiStatus_t		wsSpiConfigure		(const spiDesc_t * pSpiDesc, uint32_t baudRate, spiHandle_t * pHandle) ;
void			wsSpiSend			(spiHandle_t spiHdl, uint8_t * pBuffer, uint32_t nByte) ;

//--------------------------------------------------------------------------------
#endif // WS2812B_H_
